package com.ims.eval.config;

import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Data
@Component
//@ConfigurationProperties(prefix = "iam")
public class ImaConfig {

	@Value("${iam.active}")
	private String active;

	/**网关网址 **/
	@Value("${iam.gateway-url.dev}")
	private String gatewayUrlDev;

	@Value("${iam.gateway-url.pro}")
	private String gatewayUrlPro;

	@Value("${iam.gateway2-url.dev}")
	private String gateway2UrlDev;


	@Value("${iam.gateway2-url.pro}")
	private String gateway2UrlPro;

	@Value("${iam.menu.dev}")
	private String menuDev;

	@Value("${iam.menu.pro}")
	private String menuPro;

	@Value("${iam.flow-url.dev}")
	private String flowUrlDev;

	@Value("${iam.flow-url.pro}")
	private String flowUrlPro;

	@Value("${iam.zbdb-url.dev}")
	private String zbdbUrlDev;

	@Value("${iam.zbdb-url.pro}")
	private String zbdbUrlPro;

	public String getMenu() {

		if("dev".equals(active)) {
			return menuDev;
		}
		return menuPro;
	}

	public String getGatewayUrl() {
		if("dev".equals(active)){
			return gatewayUrlDev;
		}
		return gatewayUrlPro;
	}

	public String getGateway2Url() {
		if("dev".equals(active)){
			return gateway2UrlDev;
		}
		return gateway2UrlPro;
	}

	public String getFlowUrl() {
		if("dev".equals(active)){
			return flowUrlDev;
		}
		return flowUrlPro;
	}

	public String getZbdbUrl() {
		if("dev".equals(active)){
			return zbdbUrlDev;
		}
		return zbdbUrlPro;
	}

}
