package com.ims.eval.config.permission;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * 数据权限注解
 * @author gyee
 */
@Documented
@Target({METHOD, ANNOTATION_TYPE, TYPE})
@Retention(RUNTIME)
public @interface DataPermission {
	/**
	 * 是否要进行数据权限隔离
	 */
	boolean isPermission() default true;//true-部门数据

	boolean type() default false;//true-基层单位；


	boolean zbtype() default false;//ture-所有部门

	boolean jbtype() default false;//ture-单位；false-部门

	boolean bktype() default false;//ture-筛选板块；false-不筛选

}
