package com.ims.eval.controller;


import com.alibaba.fastjson.JSONObject;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.custom.impl.BasicIndicatorBenchmarkingService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 基础指标对标
 * </p>
 *
 * @author wang
 * @since 2023-03-03
 */
@Slf4j
@RestController
@RequestMapping("//benchmarkin")
public class BasicIndicatorBenchmarkingController {

	@Autowired
	private BasicIndicatorBenchmarkingService basicIndicatorBenchmarkingService;

	@Autowired
	private HttpServletRequest request;




	/**
	 * 获取对标数据错误
	 * @param object
	 * @return
	 */
	@PostMapping(value = "queryData1011")
	public R queryData1011(@RequestBody JSONObject object,HttpServletRequest request) {
		Map json = null;
		try {

			json = basicIndicatorBenchmarkingService.queryData1011(object,request);
		} catch (Exception e) {
			log.error("错误",e);
			return R.error().customError("获取获取对标数据错误");
		}
		return R.ok().data(json);
	}

	/**
	 * 组织机构数据
	 * @param object
	 * @param request
	 * @return
	 */
	@PostMapping(value = "queryData1015")
	public R queryData1015(@RequestBody JSONObject object,HttpServletRequest request) {
		JSONObject json = null;
		try {

			json = basicIndicatorBenchmarkingService.queryData(object,request);
		} catch (Exception e) {
			log.error("错误",e);
			return R.error().customError("获取组织机构数据错误");
		}
		return R.ok().data(json);
	}

	/**
	 * 主题域
	 * @param object
	 * @param request
	 * @return
	 */
	@PostMapping(value = "queryData1019")
	public R queryData1019(@RequestBody JSONObject object,HttpServletRequest request) {
		JSONObject json = null;
		try {

			json = basicIndicatorBenchmarkingService.queryData(object,request);
		} catch (Exception e) {
			log.error("错误",e);
			return R.error().customError("获取主题域错误");
		}
		return R.ok().data(json);
	}


	/**
	 * 指标项
	 * @param object
	 * @param request
	 * @return
	 */
	@PostMapping(value = "queryData1020")
	public R queryData1020(@RequestBody JSONObject object,HttpServletRequest request) {
		JSONObject json = null;
		try {

			json = basicIndicatorBenchmarkingService.queryData(object,request);
		} catch (Exception e) {
			log.error("错误",e);
			return R.error().customError("获取指标项错误");
		}
		return R.ok().data(json);
	}

	/**
	 * 指标项
	 * @param object
	 * @param request
	 * @return
	 */
	@PostMapping(value = "queryData1004")
	public R queryData1004(@RequestBody JSONObject object,HttpServletRequest request) {
		JSONObject json = null;
		try {

			json = basicIndicatorBenchmarkingService.queryData(object,request);
		} catch (Exception e) {
			log.error("错误",e);
			return R.error().customError("获取指标数据错误");
		}
		return R.ok().data(json);
	}



}
