package com.ims.eval.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ims.eval.config.CustomException;
import com.ims.eval.entity.CiteCalculationIndicator;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.ICiteCalculationIndicatorService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;

/**
 * <p>
 * 板块组合指标计算 前端控制器
 * </p>
 *
 * @author wang
 * @since 2023-07-12
 */
@RestController
@RequestMapping("//cite-calculation-indicator")
public class CiteCalculationIndicatorController {

	@Autowired
	private ICiteCalculationIndicatorService citeCalculationIndicatorService;


	/**
	 * 查询
	 *
	 * @param citeCalculationName 组合名称
	 * @param binSection          板块id
	 * @return
	 */
	//@ImsPreAuth("eval:binStage:view")
	@GetMapping(value = "list")
	public R list(
		@RequestParam(value = "pageNum") Integer pageNum,
		@RequestParam(value = "pageSize") Integer pageSize,
		@RequestParam(value = "citeCalculationName", required = false) String citeCalculationName,
		@RequestParam(value = "binSection", required = false) String binSection) {
		IPage<CiteCalculationIndicator> list = null;

		try {

			list = citeCalculationIndicatorService.getCiteCalculationIndicatorList(pageNum,pageSize,citeCalculationName, binSection);

			return R.ok().data(list);
		} catch (Exception e) {
			e.printStackTrace();
			return R.error().data("失败！");
		}
	}


	/**
	 * 添加
	 *
	 * @param citeCalculationIndicator
	 * @return
	 */

	@PostMapping(value = "/save")
	@ApiOperation(value = "新增(修改)", notes = "新增（修改）")
	public R addAll(@RequestBody CiteCalculationIndicator citeCalculationIndicator) {

		try {
			boolean b = citeCalculationIndicatorService.saveOrUpdate(citeCalculationIndicator);
			if (b) {
				return R.ok().data(b);
			} else {
				return R.error().data("保存失败！");
			}
		} catch (CustomException e) {
			return R.customError(e.getMessage()).data("失败！");
		}
	}


	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@PostMapping(value = "/remove/{ids}")
	@ApiOperation(value = "删除", notes = "删除")
	public R deleteAll(@PathVariable("ids") String ids) {
		String[] strings = ids.split(",");
		boolean b = citeCalculationIndicatorService.removeByIds(Arrays.asList(strings));
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error().data("删除失败！");
		}
	}


}
