package com.ims.eval.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ims.eval.entity.EvaluationPortal;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.IEvaluationPortalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * <p>
 * 考评首页 前端控制器
 * </p>
 *
 * @author wang
 * @since 2023-05-10
 */
@RestController
@RequestMapping("//evaluation/portal")
public class EvaluationPortalController {

	@Autowired
	private IEvaluationPortalService portalService;

	@GetMapping(value = "list")
	public R listAll(String binSection, String year, String season,String newyear) {
		Map<String, Object> data = portalService.getPortalData(binSection, year, season, newyear);
		return R.ok().data(data);
	}


	@GetMapping(value = "listPage")
	public R listpage(String binSection, String year, String season) {

		IPage<EvaluationPortal> list = portalService.listPage(binSection, year, season);
		return R.ok().data(list);
	}

	@GetMapping(value = "homeSeason")
	public R getHomeSeason() {
		Map<String, String> data = portalService.getHomeSeason();
		return R.ok().data(data);
	}

	/**
	 * 年度排行榜数据
	 *
	 * @param binSection binSection
	 * @param year       年度
	 * @return 结果
	 */
	@GetMapping(value = "/annualRankingData")
	public R annualRankingData(@RequestParam(value = "binSection") String binSection,
							   @RequestParam(value = "year") String year) {
		Map<String, Object> data = portalService.selectPortalList(binSection, year, null);
		return R.ok().data(data);
	}
}
