package com.ims.eval.controller;



import com.ims.eval.entity.dto.request.AddEvaluationInfoDTO;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.IOrganizationEvaluationCommonInfoService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wang
 * @since 2023-09-11
 */
@RestController
@RequestMapping("//organization-evaluation-common-info")
public class OrganizationEvaluationCommonInfoController {



	@Autowired
	private IOrganizationEvaluationCommonInfoService organizationEvaluationCommonInfoService;




	@PostMapping(value = "/addEvaluationCommonInfo")
	@ApiOperation(value = "生成单位考评明细", notes = "生成单位考评明细")
	public R addEvaluationCommonInfo(@RequestBody List<AddEvaluationInfoDTO> addEvaluationInfoDTOs) {

		boolean b = organizationEvaluationCommonInfoService.addEvaluationCommonInfo(addEvaluationInfoDTOs);
		return R.ok().data(b);
	}

	@GetMapping(value = "list")
	public R list(@RequestParam(value = "organizationEvaluationId", required = false) String organizationEvaluationId,
				  @RequestParam(value = "indicatorId", required = false) String indicatorId,
				  @RequestParam(value = "organizationId", required = false) String organizationId,
				  @RequestParam(value = "deptId", required = false) String  deptId) {
		Map list = organizationEvaluationCommonInfoService.getListAll(organizationEvaluationId, indicatorId, organizationId, deptId);
		return R.ok().data(list);
	}


	/**
	 * 批量删除
	 * @param ids
	 * @return
	 */
	@PostMapping(value = "/remove/{ids}")
	@ApiOperation(value = "删除", notes = "删除")
	public R deleteAll(@PathVariable("ids") String ids) {
		String[] strings = ids.split(",");

		boolean b = organizationEvaluationCommonInfoService.removeCommonInfos(strings);
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error().data("删除失败！");
		}
	}




}
