package com.ims.eval.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ims.eval.config.permission.DataPermission;
import com.ims.eval.entity.EvaluateReport;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ims.eval.entity.dto.response.EvaluateReportInfoResDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author wang
 * @since 2023-03-25
 */
@DataPermission
public interface EvaluateReportMapper extends BaseMapper<EvaluateReport> {


	@DataPermission(bktype=true)
	IPage<EvaluateReport>  selectListPage(Page page, @Param("id") String id,
		 @Param("evaluateReportName")String evaluateReportName,
		 @Param("binSection")String binSection,
		 @Param("organizationEvaluationId") String organizationEvaluationId,
		 @Param("organizationType")String organizationType,
		 @Param("checkCycle")String checkCycle,
		 @Param("year")String year,
		 @Param("month")String month);



	@DataPermission(isPermission = false)
	 List<EvaluateReportInfoResDTO> selectList(@Param("binSection")String binSection,
											   @Param("organizationEvaluationId") String organizationEvaluationId,
											   @Param("checkCycle")String checkCycle,
											   @Param("year")String year,
											   @Param("month")String month);


	@DataPermission(isPermission = false)
	List<EvaluateReport> selectListAll(@Param("organizationEvaluationId") String organizationEvaluationId,
									   @Param("binSection")String binSection);

}
