package com.ims.eval.dao;

import com.ims.eval.config.permission.DataPermission;
import com.ims.eval.entity.OrganizationEvaluation;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ims.eval.entity.dto.response.EvaluationScoreInfoResDTO;
import com.ims.eval.entity.dto.response.OrganizationEvaluationResDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 单位/部门考评记录 Mapper 接口
 * </p>
 *
 * @author wang
 * @since 2023-03-16
 */
@DataPermission
public interface OrganizationEvaluationMapper extends BaseMapper<OrganizationEvaluation> {

	@DataPermission(isPermission = false)
	OrganizationEvaluationResDTO selectById(@Param("id")String id);


	@DataPermission(isPermission = false)
	List<Map<String, Object>> selectCompanyActualValue(String binSection, String indicatorId, String evaluationType);


	@DataPermission(isPermission = true,type = true,jbtype=true)
	List<EvaluationScoreInfoResDTO> selectEvaluationScoreInfoList(@Param("id") String id,
																  @Param("binSection") String binSection,
																  @Param("indicatorId") String indicatorId,
																  @Param("organizationEvaluationRuleId") String  organizationEvaluationRuleId);

}
