package com.ims.eval.dao;

import com.ims.eval.config.permission.DataPermission;
import com.ims.eval.entity.ResponsibilityIndicatorInfo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ims.eval.entity.dto.response.ResponsibilityIndicatorInfoResDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 责任书指标明细  Mapper 接口
 * </p>
 *
 * @author wang
 * @since 2023-03-08
 */
@DataPermission
public interface ResponsibilityIndicatorInfoMapper extends BaseMapper<ResponsibilityIndicatorInfo> {



	List<ResponsibilityIndicatorInfoResDTO> listByresponsibilityId(@Param("deptResponsibilityIds") List<String> deptResponsibilityIds,
																   @Param("dept") String dept,
																   @Param("optionCode") String optionCode,
																   @Param("organizationId") String organizationId);

	@DataPermission(isPermission = true,type = true,jbtype=true)
	List<ResponsibilityIndicatorInfoResDTO> selectResponsibilityIndicatorInfoList(@Param("deptResponsibilityId") String deptResponsibilityId,
																				  @Param("isQuantified") String isQuantified,
																				  @Param("dataState") String dataState);


	@DataPermission(type = true,jbtype=true)
	List<Map> selectResponsibilityIndicatorList(@Param("responsibilityId") String responsibilityId,
												@Param("binSection") String binSection,
												@Param("binStage") String binStage,
												@Param("reviseId") String reviseId);

	@DataPermission(isPermission = true,type = true,jbtype=true)
	List<ResponsibilityIndicatorInfoResDTO> getResponsibilityInfoList(@Param("responsibilityId") String responsibilityId,
																	  @Param("indicatorId") String indicatorId,
																	  @Param("organizationShortName") String organizationShortName,
																	  @Param("binSection") String binSection,
																	  @Param("binStage") String binStage,
																	  @Param("dataState") String dataState,
																	  @Param("reviseId") String reviseId);

    List<ResponsibilityIndicatorInfo> selectReviseResponsibilityIndicatorInfoList(@Param("organizationId") String organizationId, @Param("year") String year);
}
