package com.ims.eval.entity;

import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 板块组合指标计算
 * </p>
 *
 * @author wang
 * @since 2023-07-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class 	CiteCalculationIndicator extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private String id;

    /**
     * 指标id;用逗号隔开
     */
    private String indicatorIds;

    /**
     * 指标名称；多个用逗号隔开
     */
    private String indicatorNames;

    /**
     * 组合名称描述
     */
    private String citeCalculationName;

    /**
     * 排序
     */
    private BigDecimal orderNum;

	/**
	 * 板块
	 */
	private String binSection;

	/**
	 * 板块明
	 */
	@TableField(exist = false)
	private String binSectionName;


	/**
	 * 周期（年度。季度/月）
	 */
	private String  evaluationCycle;



}
