package com.ims.eval.entity;

import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

/**
 * @author hlf
 * @date 2023/5/29 14:56
 * 文件说明：绩效结果考核申报
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class DeptAssessmentDeclaration extends Model {

	private static final long serialVersionUID = 1L;

	//主键
	@JsonSerialize(using = ToStringSerializer.class)
	private String id;
	//单号规则
	private String orderNumber;
	//部门主键
	private String deptId;
	//部门名称
	private String deptName;
	//年度
	private Integer annual;
	//申报月份
	private Integer declarationMonth;
	//申报等级
	private String declarationLevel;
	//评定等级
	private String ratingGrade;
	//部门领导主键
	private String deptLeaderId;
	//部门领导编号
	private String deptLeaderNo;
	//部门领导名称
	private String deptLeaderName;
	//申报理由
	private String declarationReason;
	//申报人
	private String applicantId;
	//申报人名称
	private String applicantName;
	//申报时间
	private Date declarationTime;
	//流程状态
	private String stage;
	//流程实例ID
	private String instId;
	//创建时间
	private Date createTime;
	//创建者
	private String createBy;
	//创建者名称
	private String createName;
	//更新时间
	private Date updateTime;
	//更新者
	private String updateBy;
	//备注
	private String remark;
	//复批人主键
	private String seconderId;
	//复批人编号
	private String seconderNo;
	//复批人名称
	private String seconderName;
}
