package com.ims.eval.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

/**
 * @author hlf
 * @date 2023/5/6 10:36
 * 文件说明：本部部门业绩指标计划内容
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class EvaluationDeptBusinessContent extends Model {

	private static final long serialVersionUID = 1L;

	/**
	 * 主键
	 */
	private String id;

	/**
	 * 指标计划主键
	 */
	private String businessPlanId;

	/**
	 * 考评部门主键
	 */
	private String deptId;

	/**
	 * 考评部门名称
	 */
	private String deptName;

	/**
	 * 序号
	 */
	private Integer serialNumber;

	/**
	 * 指标名称
	 */
	private String targetName;

	/**
	 * 目标值
	 */
	private String targetValue;

	/**
	 * 基础分
	 */
	private String baseScore;

	/**
	 * 完成情况
	 */
	private String completionStatus;

	/**
	 * 评价标准
	 */
	private String evaluationCriteria;

	/**
	 * 自评得分
	 */
	private String evaluationScore;

	/**
	 * 计划审核状态(-1待审核、0已通过、-2未通过)
	 */
	private String auditStatus;

	/**
	 * 考评审核状态(-1待审核、0已通过、-2未通过)
	 */
	private String auditStatusKp;

	/**
	 * 创建时间
	 */
	private Date createTime;

	/**
	 * 创建者
	 */
	private String createBy;

	/**
	 * 创建者名称
	 */
	private String createName;

	/**
	 * 创建者部门
	 */
	private String createDept;

	/**
	 * 更新时间
	 */
	private Date updateTime;

	/**
	 * 更新者
	 */
	private String updateBy;

	/**
	 * 备注
	 */
	private String remark;

	/**
	 * 数据权限(-1置灰 1正常)
	 */
	@TableField(exist = false)
	private String dataPermission;
}
