package com.ims.eval.service;

import com.alibaba.fastjson.JSONObject;
import com.ims.eval.entity.ResponsibilityIndicatorInfo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ims.eval.entity.dto.request.ResponsibilityIndicatorInfoUpdateDTO;
import com.ims.eval.entity.dto.response.ResponsibilityIndicatorInfoResDTO;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 责任书指标明细

 服务类
 * </p>
 *
 * @author wang
 * @since 2023-03-08
 */
public interface IResponsibilityIndicatorInfoService extends IService<ResponsibilityIndicatorInfo> {


	Map<Object  ,List<ResponsibilityIndicatorInfoResDTO>> planValueList(List<String> deptResponsibilityIds, String dept, HttpServletRequest request);

	boolean saveOrUpdateDto(ResponsibilityIndicatorInfoUpdateDTO infoUpdateDTO);

	boolean saveBatchDto(List<ResponsibilityIndicatorInfoUpdateDTO> infoUpdateDTOs);

	Map<String ,Object> getResponsibilityIdMap(String deptResponsibilityId);

	boolean revisionResponsibilityIndicatorInfo(List<JSONObject> jsonObjects);

	List<ResponsibilityIndicatorInfoResDTO> selectPopUpData(String deptResponsibilityId, String isQuantified, String dataState);


	List<Map> getResponsibilityIndicatorList(String responsibilityId, String binSection, String binStage, HttpServletRequest request);


	Map  getResponsibilityInfoList(String responsibilityId, String indicatorId,String organizationShortName,String binSection,String binStage, HttpServletRequest request);

	boolean updateResponsibilityIndicatorInfo(List<JSONObject> jsonObjects);


	byte[] downloadExcel(String responsibilityId, String indicatorId, String binSection, String binStage, HttpServletRequest request)throws Exception;

	boolean importExcel(MultipartFile file, HttpServletRequest request) throws Exception;


	 List<ResponsibilityIndicatorInfo> getResponsibilityInfooByOptionCodeList(String organizationEvaluationId, String organizationId, String childOptionCode);

	List<ResponsibilityIndicatorInfo> selectReviseResponsibilityIndicatorInfoList(String organizationId, String year);
}
