package com.ims.eval.service;

import com.alibaba.fastjson.JSONObject;
import com.ims.eval.entity.Myuser;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ims.eval.entity.dto.response.MyuserResDTO;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author wang
 * @since 2023-03-03
 */
public interface IUserService extends IService<Myuser> {

	List<Myuser> listAll(String id, String orgId, String unitId);


	/**
	 * 通过用户名密码查询一个用户
	 *
	 * @param username
	 * @return
	 */
	Myuser getUser(String username);


	/**
	 * 更新用户
	 *
	 * @param user
	 * @return
	 */
	void updateUser(Myuser user);

	/**
	 * 通过code获取user
	 *
	 * @param code
	 * @return
	 */
	MyuserResDTO getSysUser(String code);

	/**
	 * 根据头信息
	 * @param request
	 * @return
	 */
	MyuserResDTO getSysUser(HttpServletRequest request);



	/**
	 * 通过token获取code
	 *
	 * @param token
	 * @return
	 */
	JSONObject getCodeByToken(String token);


	/**
	 * 登录
	 *
	 * @param username
	 * @param password
	 * @return
	 */
	JSONObject getbladeAuth(String tenantId, String username, String password, String grantType, String scope, String type) throws Exception;

	/**
	 * 分页获取用户
	 * @param current
	 * @param size
	 * @param orgId
	 * @param idCard
	 * @param mobile
	 * @param no
	 * @param name
	 * @param loginName
	 * @return
	 */
	JSONObject pageList(Integer current, Integer size, String orgId, String idCard, String mobile, String no,String name,String loginName,HttpServletRequest request);

	/**
	 * 登录
	 *
	 * @param username
	 * @param password
	 * @return
	 */
	JSONObject getbladeAuth(String username, String password) throws Exception;

	JSONObject getLoginNameByUserInfo(String info, HttpServletRequest request);
}
