package com.ims.eval.service.custom;



/**
 * 工作流业务类
 */
public interface WorkflowService {



	/**
	 *  流程启动前
	 * @param instId 业务类
	 * @param defKey 流程key
	 * @param bizKey  自定义key(一般存主数据id)
	 * @param taskName 流程节点名称
	 * @return
	 */
	boolean beforeStartAction(String instId, String defKey, String bizKey,String taskName);

	/**
	 * 流程启动后
	 * @param instId 业务类
	 * @param defKey 流程key
	 * @param bizKey  自定义key(一般存主数据id)
	 * @param taskName 流程节点名称
	 * @return
	 */
	boolean afterStartAction(String instId, String defKey, String bizKey,String taskName);


	/**
	 *  流程审批前
	 * @param instId 业务类
	 * @param defKey 流程key
	 * @param bizKey  自定义key(一般存主数据id)
	 * @param taskName 流程节点名称
	 * @return
	 */
	boolean beforeCheckAction(String instId, String defKey, String bizKey, String taskName);


	/**
	 * 流程审批后
	 * @param instId 业务类
	 * @param defKey 流程key
	 * @param bizKey  自定义key(一般存主数据id)
	 * @param taskName 流程节点名称
	 * @return
	 */
	boolean afterCheckAction(String instId, String defKey, String bizKey, String taskName);



}
