package com.ims.eval.service.custom.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ims.eval.config.ImaConfig;
import com.ims.eval.entity.custom.BbkResult;
import com.ims.eval.entity.custom.Data1011Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 基础指标对标 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-12
 */
@Service
@Slf4j
public class BasicIndicatorBenchmarkingService {

	@Autowired
	private RestTemplate restTemplate;

	@Autowired
	private ImaConfig imaConfig;


	/**
	 * 获取对标数据错误
	 *
	 * @param body
	 * @return
	 */
	public JSONObject queryData(JSONObject body, HttpServletRequest request) {
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("zb-token", "a1d48f2759e0f311375247eb1f7462cad8e64f8b21654c1a9f02f43b45976ff7");

		//请求参数为body
		HttpEntity<String> requestEntity = new HttpEntity<>(body.toString(), headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getZbdbUrl() + "/queryData", HttpMethod.POST, requestEntity, String.class);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
			return JSON.parseObject(responseEntity2.getBody());
		}
		return null;
	}

	/**
	 * 获取对标数据错误
	 *
	 * @param body
	 * @return
	 */
	public Map queryData1011(JSONObject body, HttpServletRequest request) {
		Map count = new LinkedHashMap();
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("zb-token", "a1d48f2759e0f311375247eb1f7462cad8e64f8b21654c1a9f02f43b45976ff7");

		//请求参数为body
		HttpEntity<String> requestEntity = new HttpEntity<>(body.toString(), headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getZbdbUrl() + "/queryData", HttpMethod.POST, requestEntity, String.class);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
//		if (200 ==200) {
//			String str = "{\"msg\":\"success\",\"code\":200,\"data\":[{\"lastTime\":\"\",\"valueTime\":\"2022-01-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2022-01-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-01-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":33.88,\"shangQiValue\":20.25,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":202.81,\"tongBi\":80.99,\"time\":\"2022-01-01\",\"value\":61.32},{\"lastTime\":\"\",\"valueTime\":\"2022-01-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":88.618975,\"shangQiValue\":92.956549,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":1.07,\"tongBi\":6.01,\"time\":\"2022-01-01\",\"value\":93.946996},{\"lastTime\":\"\",\"valueTime\":\"2022-02-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":57.43,\"shangQiValue\":61.32,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-66.93,\"tongBi\":-64.69,\"time\":\"2022-02-01\",\"value\":20.28},{\"lastTime\":\"\",\"valueTime\":\"2022-02-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":85.469793,\"shangQiValue\":93.946996,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-1.37,\"tongBi\":8.42,\"time\":\"2022-02-01\",\"value\":92.66242},{\"lastTime\":\"\",\"valueTime\":\"2022-02-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2022-02-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-03-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":46.48,\"shangQiValue\":20.28,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":73.77,\"tongBi\":-24.18,\"time\":\"2022-03-01\",\"value\":35.24},{\"lastTime\":\"\",\"valueTime\":\"2022-03-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2022-03-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-03-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":90.661343,\"shangQiValue\":92.66242,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-5.12,\"tongBi\":-3.03,\"time\":\"2022-03-01\",\"value\":87.916312},{\"lastTime\":\"\",\"valueTime\":\"2022-04-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":47.98,\"shangQiValue\":35.24,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":8.48,\"tongBi\":-20.32,\"time\":\"2022-04-01\",\"value\":38.23},{\"lastTime\":\"\",\"valueTime\":\"2022-04-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2022-04-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-04-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":89.783951,\"shangQiValue\":87.916312,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":2.67,\"tongBi\":0.53,\"time\":\"2022-04-01\",\"value\":90.262056},{\"lastTime\":\"\",\"valueTime\":\"2022-05-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":82.979214,\"shangQiValue\":90.262056,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"05-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":2.16,\"tongBi\":11.13,\"time\":\"2022-05-01\",\"value\":92.215909},{\"lastTime\":\"\",\"valueTime\":\"2022-05-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":43.28,\"shangQiValue\":38.23,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"05-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-0.6,\"tongBi\":-12.2,\"time\":\"2022-05-01\",\"value\":38.0},{\"lastTime\":\"\",\"valueTime\":\"2022-06-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":88.363904,\"shangQiValue\":92.215909,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"06-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":0.74,\"tongBi\":5.13,\"time\":\"2022-06-01\",\"value\":92.900962},{\"lastTime\":\"\",\"valueTime\":\"2022-06-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":52.97,\"shangQiValue\":38.0,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"06-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":20.95,\"tongBi\":-13.23,\"time\":\"2022-06-01\",\"value\":45.96},{\"lastTime\":\"\",\"valueTime\":\"2022-06-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":\"\",\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"06-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":\"\",\"tongBi\":0.02,\"time\":\"2022-06-01\",\"value\":100.020309},{\"lastTime\":\"\",\"valueTime\":\"2022-07-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":43.99,\"shangQiValue\":45.96,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"07-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-52.55,\"tongBi\":-50.42,\"time\":\"2022-07-01\",\"value\":21.81},{\"lastTime\":\"\",\"valueTime\":\"2022-07-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":86.589726,\"shangQiValue\":92.900962,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"07-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":1.44,\"tongBi\":8.84,\"time\":\"2022-07-01\",\"value\":94.241642},{\"lastTime\":\"\",\"valueTime\":\"2022-07-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.020309,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"07-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":-0.01,\"tongBi\":0.01,\"time\":\"2022-07-01\",\"value\":100.007639},{\"lastTime\":\"\",\"valueTime\":\"2022-08-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":87.214544,\"shangQiValue\":94.241642,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"08-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-0.62,\"tongBi\":7.39,\"time\":\"2022-08-01\",\"value\":93.658636},{\"lastTime\":\"\",\"valueTime\":\"2022-08-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":50.15,\"shangQiValue\":21.81,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"08-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":95.28,\"tongBi\":-15.07,\"time\":\"2022-08-01\",\"value\":42.59},{\"lastTime\":\"\",\"valueTime\":\"2022-08-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.007639,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"08-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":-0.01,\"tongBi\":0.0,\"time\":\"2022-08-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-09-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":94.664469,\"shangQiValue\":93.658636,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"09-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-1.14,\"tongBi\":-2.19,\"time\":\"2022-09-01\",\"value\":92.586768},{\"lastTime\":\"\",\"valueTime\":\"2022-09-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":51.81,\"shangQiValue\":42.59,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"09-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":17.37,\"tongBi\":-3.51,\"time\":\"2022-09-01\",\"value\":49.99},{\"lastTime\":\"\",\"valueTime\":\"2022-09-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"09-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":-0.01,\"tongBi\":-0.01,\"time\":\"2022-09-01\",\"value\":99.994872},{\"lastTime\":\"\",\"valueTime\":\"2022-10-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":99.994872,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"10-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.01,\"tongBi\":0.0,\"time\":\"2022-10-01\",\"value\":100.0},{\"lastTime\":\"\",\"valueTime\":\"2022-10-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":93.146999,\"shangQiValue\":92.586768,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"10-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-3.0,\"tongBi\":-3.58,\"time\":\"2022-10-01\",\"value\":89.808183},{\"lastTime\":\"\",\"valueTime\":\"2022-10-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":34.76,\"shangQiValue\":49.99,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"10-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-1.72,\"tongBi\":41.34,\"time\":\"2022-10-01\",\"value\":49.13},{\"lastTime\":\"\",\"valueTime\":\"2022-11-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":48.79,\"shangQiValue\":49.13,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"11-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-22.15,\"tongBi\":-21.6,\"time\":\"2022-11-01\",\"value\":38.25},{\"lastTime\":\"\",\"valueTime\":\"2022-11-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":91.726802,\"shangQiValue\":89.808183,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"11-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":3.36,\"tongBi\":1.2,\"time\":\"2022-11-01\",\"value\":92.826672},{\"lastTime\":\"\",\"valueTime\":\"2022-11-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":100.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"11-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2022-11-01\",\"value\":99.997081},{\"lastTime\":\"\",\"valueTime\":\"2022-12-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":92.956549,\"shangQiValue\":92.826672,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"12-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":9.51,\"tongBi\":9.35,\"time\":\"2022-12-01\",\"value\":101.65069},{\"lastTime\":\"\",\"valueTime\":\"2022-12-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":20.25,\"shangQiValue\":38.25,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"12-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":49.1,\"tongBi\":181.62,\"time\":\"2022-12-01\",\"value\":57.028846},{\"lastTime\":\"\",\"valueTime\":\"2022-12-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":99.997081,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"12-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":-0.01,\"time\":\"2022-12-01\",\"value\":99.994666},{\"lastTime\":\"\",\"valueTime\":\"2023-01-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":99.994666,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":\"\",\"tongBi\":0.0,\"time\":\"2023-01-01\",\"value\":0.0},{\"lastTime\":\"\",\"valueTime\":\"2023-01-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":93.946996,\"shangQiValue\":101.65069,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-99.97,\"tongBi\":-99.97,\"time\":\"2023-01-01\",\"value\":0.028918},{\"lastTime\":\"\",\"valueTime\":\"2023-01-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":61.32,\"shangQiValue\":57.028846,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"01-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":\"\",\"tongBi\":0.0,\"time\":\"2023-01-01\",\"value\":0.0},{\"lastTime\":\"\",\"valueTime\":\"2023-02-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":0.0,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":\"\",\"tongBi\":0.0,\"time\":\"2023-02-01\",\"value\":99.995573},{\"lastTime\":\"\",\"valueTime\":\"2023-02-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":92.66242,\"shangQiValue\":0.028918,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":299451.42,\"tongBi\":-6.52,\"time\":\"2023-02-01\",\"value\":86.624281},{\"lastTime\":\"\",\"valueTime\":\"2023-02-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":20.28,\"shangQiValue\":0.0,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"02-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":\"\",\"tongBi\":195.87,\"time\":\"2023-02-01\",\"value\":60.001868},{\"lastTime\":\"\",\"valueTime\":\"2023-03-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":87.916312,\"shangQiValue\":86.624281,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":-4.31,\"tongBi\":-5.71,\"time\":\"2023-03-01\",\"value\":82.893592},{\"lastTime\":\"\",\"valueTime\":\"2023-03-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":99.995573,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2023-03-01\",\"value\":99.995426},{\"lastTime\":\"\",\"valueTime\":\"2023-03-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":35.24,\"shangQiValue\":60.001868,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"03-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":-33.55,\"tongBi\":13.15,\"time\":\"2023-03-01\",\"value\":39.87385},{\"lastTime\":\"\",\"valueTime\":\"2023-04-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":90.262056,\"shangQiValue\":82.893592,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":2.73,\"tongBi\":-5.66,\"time\":\"2023-04-01\",\"value\":85.155119},{\"lastTime\":\"\",\"valueTime\":\"2023-04-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":38.23,\"shangQiValue\":39.87385,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":0.95,\"tongBi\":5.29,\"time\":\"2023-04-01\",\"value\":40.254018},{\"lastTime\":\"\",\"valueTime\":\"2023-04-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":100.0,\"shangQiValue\":99.995426,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"04-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":0.0,\"time\":\"2023-04-01\",\"value\":99.996226},{\"lastTime\":\"\",\"valueTime\":\"2023-05-0100:00:00\",\"orgName\":\"盘山公司\",\"unitName\":\"盘山公司\",\"irn\":2500017,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08621112201-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":\"\",\"shangQiValue\":99.996226,\"itemName\":\"盘山公司电费回收率本月完成值合计(管理口径)\",\"month\":\"05-01\",\"orgCode\":\"08621112201\",\"unitCode\":\"08621112201\",\"huanBi\":0.0,\"tongBi\":\"\",\"time\":\"2023-05-01\",\"value\":99.995309},{\"lastTime\":\"\",\"valueTime\":\"2023-05-0100:00:00\",\"orgName\":\"国电电力\",\"unitName\":\"国电电力\",\"irn\":2500000,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08611010501-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":92.215909,\"shangQiValue\":85.155119,\"itemName\":\"国电电力电费回收率本月完成值合计(管理口径)\",\"month\":\"05-01\",\"orgCode\":\"08611010501\",\"unitCode\":\"08611010501\",\"huanBi\":1.33,\"tongBi\":-6.43,\"time\":\"2023-05-01\",\"value\":86.284732},{\"lastTime\":\"\",\"valueTime\":\"2023-05-0100:00:00\",\"orgName\":\"山西新能源\",\"unitName\":\"山西新能源\",\"irn\":2500074,\"fdlx\":\"\",\"itemCode\":\"30010401003\",\"indexCode\":\"ZB-08614020004-99999999-30010401003-M-DS01(GL)\",\"tongQiValue\":38.0,\"shangQiValue\":40.254018,\"itemName\":\"山西新能源电费回收率本月完成值合计(管理口径)\",\"month\":\"05-01\",\"orgCode\":\"08614020004\",\"unitCode\":\"08614020004\",\"huanBi\":43.66,\"tongBi\":52.18,\"time\":\"2023-05-01\",\"value\":57.830109}],\"dataType\":\"根据组织机构,获取指标数据\"}";
			BbkResult result = JSON.parseObject(responseEntity2.getBody()).toJavaObject(BbkResult.class);
//			BbkResult result = JSON.parseObject(str).toJavaObject(BbkResult.class);
			if (200 == result.getCode()) {
				List<Data1011Result> list = result.getData();
				// 填充动态头部分组并保持顺序，然后对每个分组内的元素按 time 降序排序
				Map<String, List<Data1011Result>> orgCodeSortedByTime = list.stream()
					.collect(Collectors.groupingBy(
						data -> data.getOrgCode() + "_" + data.getOrgName(), // 使用orgCode和orgName的组合作为键
						Collectors.collectingAndThen(
							Collectors.toList(),
							l -> list.stream()
								.sorted(Comparator.comparing(Data1011Result::getTime)) // 按time升序排序
								.collect(Collectors.toList())
						)
					));


				//填充标题
				List<Map> titleArray = new ArrayList<>();
				final Map[] titletime = {null};
				orgCodeSortedByTime.forEach((key, results) -> {

					String[] parts = key.split("_");
					String orgCode = parts[0];
					String orgName = parts[1];

					if(null == titletime[0]){
						titletime[0] = new LinkedHashMap();
						titletime[0].put("name", "频度");//名称
						titletime[0].put("code","time");//code
						titleArray.add(titletime[0]);
					}

					Map titleorg = new LinkedHashMap();
					titleorg.put("name", orgName);//名称
					titleorg.put("code",orgCode);//code
					titleArray.add(titleorg);


				});
				count.put("title", titleArray);


				// 填充内容 根据time字段进行分组
				List<Map> listmap = new ArrayList<>();
				Map<String, List<Data1011Result>> groupedByTime = list.stream()
					.collect(Collectors.groupingBy(
						Data1011Result::getTime, // 分组键是Data1011Result对象的time字段
						Collectors.toList() // 将每个组的元素收集到列表中
					))
					.entrySet()
					.stream()
					.sorted(Map.Entry.comparingByKey()) // 按键（时间）升序排序分组后的Map.Entry
					.collect(Collectors.toMap(
						Map.Entry::getKey, // 新Map的键是原Map.Entry的键
						Map.Entry::getValue, // 新Map的值是原Map.Entry的值
						(oldValue, newValue) -> oldValue, // 如果键冲突，保留旧值（理论上不应该发生，因为Map.Entry是唯一的）
						LinkedHashMap::new // 使用LinkedHashMap来保持插入顺序（这里实际上是排序后的顺序）
					));

				// 组合行
				groupedByTime.forEach((time, results) -> {
					Map row = new LinkedHashMap();
					for (Data1011Result r : results) {
						if (null == row.get("time")) {
							row.put("time", r.getTime());
							count.put("itemName",r.getItemName());
						}
						row.put(r.getOrgCode(), r.getValue());
					}
					listmap.add(row);

				});
				count.put("list", listmap);

			}
		}

		return count;
	}









}
