package com.ims.eval.service.custom.impl;

import com.ims.eval.config.CustomException;
import com.ims.eval.service.IOrganizationEvaluationInfoService;
import com.ims.eval.service.IOrganizationEvaluationService;
import com.ims.eval.service.custom.WorkflowService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

/**
 * <p>
 * 工作流 季度流程服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-12
 */
@Service
@Slf4j
public class WorkflowSeasonServiceImpl  implements WorkflowService {

	@Autowired
	private IOrganizationEvaluationService organizationEvaluationService;

	@Autowired
	private IOrganizationEvaluationInfoService organizationEvaluationInfoService;

	@Override
	public boolean beforeStartAction(String instId, String defKey, String bizKey, String taskName) {
		return false;
	}

	@Override
	public boolean afterStartAction(String instId, String defKey, String bizKey, String taskName) {
		return false;
	}

	@Override
	public boolean beforeCheckAction(String instId, String defKey, String bizKey, String taskName) {
		if("人事部审核".equals(taskName)){
			List<String> stateList = Arrays.asList("-1", "0"); // 要查询的id列表
			Integer count = organizationEvaluationInfoService.getEvaluationInfoByStateCount(bizKey,"",stateList);
			if(null!=count && count>0){
				throw new CustomException("请联系组织人事部进行指标状态确认！");
			}
		}

		if("各部门填报".equals(taskName)){
			List<String> stateList = Arrays.asList("-1", "0"); // 要查询的id列表
			Integer count = organizationEvaluationInfoService.getEvaluationInfoByStateCount(bizKey,"",stateList);
			if(null!=count && count>0){
				throw new CustomException("请联系组织人事部进行指标状态确认！");
			}
		}

		return true;
	}

	@Override
	public boolean afterCheckAction(String instId, String defKey, String bizKey, String taskName) {
		return false;
	}
}
