package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ims.eval.cache.CacheContext;
import com.ims.eval.config.CustomException;
import com.ims.eval.entity.CiteCalculationIndicator;
import com.ims.eval.dao.CiteCalculationIndicatorMapper;
import com.ims.eval.entity.Indicator;
import com.ims.eval.service.ICiteCalculationIndicatorService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 板块组合指标计算 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-07-12
 */
@Service
public class CiteCalculationIndicatorServiceImpl extends ServiceImpl<CiteCalculationIndicatorMapper, CiteCalculationIndicator> implements ICiteCalculationIndicatorService {

	@Override
	public IPage<CiteCalculationIndicator> getCiteCalculationIndicatorList(Integer pageNum, Integer pageSize, String citeCalculationName, String binSection) {
		QueryWrapper<Indicator> qw = new QueryWrapper<>();
		if (null == pageNum || null == pageSize) {
			throw new CustomException("分页参数为空");
		}
		//构造分页构造器
		Page<Indicator> page = new Page<>(pageNum, pageSize);

		IPage<CiteCalculationIndicator> list  = baseMapper.selectCiteCalculationIndicatorList(page,citeCalculationName,binSection);

		list.getRecords().stream().forEach(i->{
			StringBuilder binSectionName = new StringBuilder();
			for(String key:CacheContext.bsnIdName.keySet()){

				if(i.getBinSection().contains(key)){
					binSectionName.append(CacheContext.bsnIdName.get(key)).append(",");
				}
			}
			i.setBinSectionName(binSectionName.toString());
		});

		return list;
	}

	@Override
	public List<CiteCalculationIndicator> getListLikeIndicatorIds(String indicatorIds,String binSection) {
		List<CiteCalculationIndicator> list  = baseMapper.selectListLikeIndicatorIds(indicatorIds,binSection);
		return list;
	}

	@Override
	public boolean saveOrUpdate(CiteCalculationIndicator entity) {
		return super.saveOrUpdate(entity);
	}
}
