package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.DeptAssessmentDeclarationContentMapper;
import com.ims.eval.entity.DeptAssessmentDeclarationContent;
import com.ims.eval.service.IDeptAssessmentDeclarationContentService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author hlf
 * @date 2023/5/29 16:47
 * 文件说明：
 */
@Service
public class DeptAssessmentDeclarationContentServiceImpl extends ServiceImpl<DeptAssessmentDeclarationContentMapper, DeptAssessmentDeclarationContent> implements IDeptAssessmentDeclarationContentService {

	@Override
	public List<DeptAssessmentDeclarationContent> detailsList(String assessmentDeclarationId) {
		return baseMapper.detailsList(assessmentDeclarationId);
	}

	@Override
	public boolean removeByAssessmentDeclarationId(String assessmentDeclarationId) {
		return baseMapper.removeByAssessmentDeclarationId(assessmentDeclarationId);
	}

	@Override
	public boolean saveOrUpdateBatch(List<DeptAssessmentDeclarationContent> deptAssessmentDeclarationContentList) {
		boolean b = true;
		List<DeptAssessmentDeclarationContent> list1 = new ArrayList<>();
		List<DeptAssessmentDeclarationContent> list2 = new ArrayList<>();
		for (DeptAssessmentDeclarationContent deptAssessmentDeclarationContent : deptAssessmentDeclarationContentList) {
			if ("".equals(deptAssessmentDeclarationContent.getEmployeeId()) || "".equals(deptAssessmentDeclarationContent.getEmployeeNo()) || "".equals(deptAssessmentDeclarationContent.getEmployeeName())) {
				b = false;
				break;
			}
			if (deptAssessmentDeclarationContent.getId() == null || "".equals(deptAssessmentDeclarationContent.getId())) {//新增
				QueryWrapper<DeptAssessmentDeclarationContent> qw = new QueryWrapper<>();
				if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getAssessmentDeclarationId())) {
					qw.lambda().like(DeptAssessmentDeclarationContent::getAssessmentDeclarationId, deptAssessmentDeclarationContent.getAssessmentDeclarationId());
				}
				if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getEmployeeId())) {
					qw.lambda().like(DeptAssessmentDeclarationContent::getEmployeeId, deptAssessmentDeclarationContent.getEmployeeId());
				}
				List<DeptAssessmentDeclarationContent> objList1 = super.list(qw);
				if (objList1.size() == 0) {
					list1.add(deptAssessmentDeclarationContent);
				} else {
					b = false;
				}
			} else {//修改
				QueryWrapper<DeptAssessmentDeclarationContent> qw = new QueryWrapper<>();
				if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getId())) {
					qw.lambda().like(DeptAssessmentDeclarationContent::getId, deptAssessmentDeclarationContent.getId());
				}
				if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getAssessmentDeclarationId())) {
					qw.lambda().like(DeptAssessmentDeclarationContent::getAssessmentDeclarationId, deptAssessmentDeclarationContent.getAssessmentDeclarationId());
				}
				if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getEmployeeId())) {
					qw.lambda().like(DeptAssessmentDeclarationContent::getEmployeeId, deptAssessmentDeclarationContent.getEmployeeId());
				}
				List<DeptAssessmentDeclarationContent> objList2 = super.list(qw);
				if (objList2.size() == 1) {
					list2.add(deptAssessmentDeclarationContent);
				} else if (objList2.size() == 0) {
					QueryWrapper<DeptAssessmentDeclarationContent> qw1 = new QueryWrapper<>();
					if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getAssessmentDeclarationId())) {
						qw1.lambda().like(DeptAssessmentDeclarationContent::getAssessmentDeclarationId, deptAssessmentDeclarationContent.getAssessmentDeclarationId());
					}
					if (StringUtils.isNotEmpty(deptAssessmentDeclarationContent.getEmployeeId())) {
						qw.lambda().like(DeptAssessmentDeclarationContent::getEmployeeId, deptAssessmentDeclarationContent.getEmployeeId());
					}
					List<DeptAssessmentDeclarationContent> objList3 = super.list(qw1);
					if (objList3.size() == 0) {
						list2.add(deptAssessmentDeclarationContent);
					} else {
						b = false;
					}
				}
			}
		}
		if (b) {
			if (list1.size() > 0) {
				super.saveBatch(list1);
			}
			if (list2.size() > 0) {
				super.updateBatchById(list2);
			}
		}
		return b;
	}
}
