package com.ims.eval.service.impl;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptBusinessPlanMapper;
import com.ims.eval.entity.EvaluationDept;
import com.ims.eval.entity.EvaluationDeptBusinessAssessment;
import com.ims.eval.entity.EvaluationDeptBusinessPlan;
import com.ims.eval.entity.dto.response.MyuserResDTO;
import com.ims.eval.feign.RemoteServiceBuilder;
import com.ims.eval.service.IEvaluationDeptBusinessAssessmentService;
import com.ims.eval.service.IEvaluationDeptBusinessContentService;
import com.ims.eval.service.IEvaluationDeptBusinessPlanService;
import com.ims.eval.service.IEvaluationDeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * @author hlf
 * @date 2023/4/27 10:33
 * 文件说明：
 */
@Service
public class EvaluationDeptBusinessPlanServiceImpl extends ServiceImpl<EvaluationDeptBusinessPlanMapper, EvaluationDeptBusinessPlan> implements IEvaluationDeptBusinessPlanService {

	@Autowired
	private IEvaluationDeptBusinessContentService evaluationDeptBusinessContentService;

	@Autowired
	private IEvaluationDeptBusinessAssessmentService evaluationDeptBusinessAssessmentService;

	@Autowired
	private IEvaluationDeptService evaluationDeptService;

	@Autowired
	private RemoteServiceBuilder remoteServiceBuilder;

	@Override
	public IPage<EvaluationDeptBusinessPlan> listPage(Integer pageNum, Integer pageSize, String deptId, String responsibilityCode, String des, String appraisalYear, String stage, HttpServletRequest request) {
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationDeptBusinessPlan> page = new Page<>(pageNum, pageSize);
		IPage<EvaluationDeptBusinessPlan> list = null;
		String code = request.getHeader("code");
		JSONObject json = remoteServiceBuilder.getGatewayUrl().getSysUser(code);
		MyuserResDTO user = JSONObject.parseObject(json.getJSONObject("data").toJSONString(), MyuserResDTO.class);
		user.getDeptOrg().getType();
		if ("150".equals(user.getDeptOrg().getType())) {
			deptId = user.getDeptOrg().getParentId();
		}
		if ("23031009".equals(deptId)) {//组织人事部
			list = baseMapper.selectListPage(page, "", responsibilityCode, des, appraisalYear, stage);
		} else {
			QueryWrapper<EvaluationDept> qw = new QueryWrapper<>();
			qw.lambda().eq(EvaluationDept::getYjzbjhType, "1");
			List<EvaluationDept> evaluationDeptList = evaluationDeptService.list(qw);
			String finalDeptId = deptId;
			EvaluationDept evaluationDept = evaluationDeptList.stream().filter(item -> item.getDeptId().equals(finalDeptId)).findFirst().orElse(null);
			if (evaluationDept != null) {
				list = baseMapper.selectListPage(page, finalDeptId, responsibilityCode, des, appraisalYear, stage);
			}
		}
		return list;
	}

	@Override
	public boolean save(EvaluationDeptBusinessPlan evaluationDeptBusinessPlan) {
		List<EvaluationDeptBusinessPlan> list = new ArrayList<>();
		QueryWrapper<EvaluationDept> qw = new QueryWrapper<>();
		qw.lambda().eq(EvaluationDept::getYjzbjhType, "1");
		List<EvaluationDept> evaluationDeptList = evaluationDeptService.list(qw);
		for (EvaluationDept dept : evaluationDeptList) {
			QueryWrapper<EvaluationDeptBusinessPlan> qw1 = new QueryWrapper<>();
			qw1.lambda().eq(EvaluationDeptBusinessPlan::getAppraisalYear, evaluationDeptBusinessPlan.getAppraisalYear());
			qw1.lambda().eq(EvaluationDeptBusinessPlan::getDeptId, evaluationDeptBusinessPlan.getDeptId());
			EvaluationDeptBusinessPlan businessPlan = super.getOne(qw1);
			if (null == businessPlan) {
				EvaluationDeptBusinessPlan plan = new EvaluationDeptBusinessPlan();
				plan.setId(Convert.toStr(IdUtil.getSnowflake(1, 1).nextId()));
				plan.setResponsibilityCode("ZBJH_" + dept.getDeptId() + "_" + evaluationDeptBusinessPlan.getAppraisalYear() + getThreePipelineNumbers());
				plan.setAppraisalYear(evaluationDeptBusinessPlan.getAppraisalYear());
				plan.setEvaluationCategory("BMKP");
				plan.setBusinessClass("NDKP");
				plan.setDocumentStatus("有效");
				plan.setStage("流程未启动");
				plan.setDes(dept.getDeptName() + evaluationDeptBusinessPlan.getAppraisalYear() + "年度业绩指标计划申报");
				plan.setCreateTime(DateUtil.date());
				plan.setCreateBy(evaluationDeptBusinessPlan.getCreateBy());
				plan.setCreateName(evaluationDeptBusinessPlan.getCreateName());
				plan.setDeptId(dept.getDeptId());
				plan.setDeptName(dept.getDeptName());
				list.add(plan);
			}
		}
		return super.saveBatch(list);
	}

	@Override
	public boolean editState(String id, String state, String instId) {
		EvaluationDeptBusinessPlan evaluationDeptBusinessPlan = baseMapper.selectById(id);
		if (StringUtils.isNotEmpty(state)) {
			if ("组织人事部领导审核".equals(state)) {
				state = "流程已结束";
				EvaluationDeptBusinessAssessment evaluationDeptBusinessAssessment = new EvaluationDeptBusinessAssessment();
				evaluationDeptBusinessAssessment.setId(evaluationDeptBusinessPlan.getId());
				evaluationDeptBusinessAssessment.setResponsibilityCode("ZBKP_" + evaluationDeptBusinessPlan.getDeptId() + "_" + evaluationDeptBusinessPlan.getAppraisalYear() + getThreePipelineNumbers());
				evaluationDeptBusinessAssessment.setAppraisalYear(evaluationDeptBusinessPlan.getAppraisalYear());
				evaluationDeptBusinessAssessment.setEvaluationCategory(evaluationDeptBusinessPlan.getEvaluationCategory());
				evaluationDeptBusinessAssessment.setBusinessClass(evaluationDeptBusinessPlan.getBusinessClass());
				evaluationDeptBusinessAssessment.setDocumentStatus(evaluationDeptBusinessPlan.getDocumentStatus());
				evaluationDeptBusinessAssessment.setStage("流程未启动");
				evaluationDeptBusinessAssessment.setDes(evaluationDeptBusinessPlan.getDes());
				evaluationDeptBusinessAssessment.setCreateTime(DateUtil.date());
				evaluationDeptBusinessAssessment.setRemark(evaluationDeptBusinessPlan.getRemark());
				evaluationDeptBusinessAssessment.setDeptId(evaluationDeptBusinessPlan.getDeptId());
				evaluationDeptBusinessAssessment.setDeptName(evaluationDeptBusinessPlan.getDeptName());
				evaluationDeptBusinessAssessmentService.save(evaluationDeptBusinessAssessment);
			}
			evaluationDeptBusinessPlan.setStage(state);
		}
		if (StringUtils.isNotEmpty(instId)) {
			evaluationDeptBusinessPlan.setInstId(instId);
		}
		return super.saveOrUpdate(evaluationDeptBusinessPlan);
	}

	@Override
	public boolean removeByIds(List<String> ids) {
		for (String id : ids) {
			EvaluationDeptBusinessPlan evaluationDeptBusinessPlan = super.getById(id);
			if ("流程未启动".equals(evaluationDeptBusinessPlan.getStage())) {
				boolean b = super.removeById(id);
				if (b) {
					evaluationDeptBusinessAssessmentService.removeById(id);
					evaluationDeptBusinessContentService.removeByBusinessPlanId(id);
				}
			}
		}
		return true;
	}

	@Override
	public boolean updateById(EvaluationDeptBusinessPlan evaluationDeptBusinessPlan) {
		evaluationDeptBusinessPlan.setUpdateTime(DateUtil.date());
		EvaluationDeptBusinessAssessment evaluationDeptBusinessAssessment = new EvaluationDeptBusinessAssessment();
		evaluationDeptBusinessAssessment.setId(evaluationDeptBusinessPlan.getId());
		evaluationDeptBusinessAssessment.setDes(evaluationDeptBusinessPlan.getDes());
		evaluationDeptBusinessAssessmentService.updateById(evaluationDeptBusinessAssessment);
		return super.updateById(evaluationDeptBusinessPlan);
	}

	@Override
	public List<EvaluationDeptBusinessPlan> selectEvaluationDeptBusinessPlanByYear(String year) {
		return baseMapper.selectEvaluationDeptBusinessPlanByYear(year);
	}

	/**
	 * @return 获取三位流水号
	 */
	public String getThreePipelineNumbers() {
		String code = "";
		int num = super.count() + 1;
		DecimalFormat def = new DecimalFormat("000");
		code += def.format(num);
		return code;
	}
}
