package com.ims.eval.service.impl;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptRatingMapper;
import com.ims.eval.entity.EvaluationDeptRating;
import com.ims.eval.entity.dto.response.MyuserResDTO;
import com.ims.eval.feign.RemoteServiceBuilder;
import com.ims.eval.service.IEvaluationDeptRatingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author hlf
 * @date 2023/4/28 16:16
 * 文件说明：
 */
@Service
public class EvaluationDeptRatingServiceImpl extends ServiceImpl<EvaluationDeptRatingMapper, EvaluationDeptRating> implements IEvaluationDeptRatingService {


	@Autowired
	private RemoteServiceBuilder remoteServiceBuilder;

	@Override
	public IPage<EvaluationDeptRating> listPage(Integer pageNum, Integer pageSize, String deptId, String deptName, String annual) {
		if ("23031009".equals(deptId)) {//组织人事部
			deptId = "";
		}
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationDeptRating> page = new Page<>(pageNum, pageSize);
		return baseMapper.selectListPage(page, deptId, deptName, annual);
	}

	@Override
	public boolean saveOrUpdate(EvaluationDeptRating evaluationDeptRating) {
		if (StringUtils.isEmpty(evaluationDeptRating.getId())){
			QueryWrapper<EvaluationDeptRating> qw = new QueryWrapper<>();
			if (StringUtils.isNotEmpty(evaluationDeptRating.getDeptId())) {
				qw.lambda().eq(EvaluationDeptRating::getDeptId, evaluationDeptRating.getDeptId());
			}
			if (StringUtils.isNotEmpty(evaluationDeptRating.getAnnual())) {
				qw.lambda().eq(EvaluationDeptRating::getAnnual, evaluationDeptRating.getAnnual());
			}
			EvaluationDeptRating deptRating = baseMapper.selectOne(qw);
			if (ObjectUtil.isNotNull(deptRating)){//不为空 表示重复
				return false;
			}
		}
		int countA = 0;
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJan()) && "A".equals(evaluationDeptRating.getJan())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getFeb()) && "A".equals(evaluationDeptRating.getFeb())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMar()) && "A".equals(evaluationDeptRating.getMar())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getApr()) && "A".equals(evaluationDeptRating.getApr())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMay()) && "A".equals(evaluationDeptRating.getMay())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJun()) && "A".equals(evaluationDeptRating.getJun())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJul()) && "A".equals(evaluationDeptRating.getJul())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getAug()) && "A".equals(evaluationDeptRating.getAug())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getSep()) && "A".equals(evaluationDeptRating.getSep())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getOct()) && "A".equals(evaluationDeptRating.getOct())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getNov()) && "A".equals(evaluationDeptRating.getNov())){
			countA += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getDece()) && "A".equals(evaluationDeptRating.getDece())){
			countA += 1;
		}
		evaluationDeptRating.setAcount(Convert.toStr(countA));
		int countC = 0;
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJan()) && "C".equals(evaluationDeptRating.getJan())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getFeb()) && "C".equals(evaluationDeptRating.getFeb())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMar()) && "C".equals(evaluationDeptRating.getMar())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getApr()) && "C".equals(evaluationDeptRating.getApr())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMay()) && "C".equals(evaluationDeptRating.getMay())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJun()) && "C".equals(evaluationDeptRating.getJun())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJul()) && "C".equals(evaluationDeptRating.getJul())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getAug()) && "C".equals(evaluationDeptRating.getAug())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getSep()) && "C".equals(evaluationDeptRating.getSep())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getOct()) && "C".equals(evaluationDeptRating.getOct())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getNov()) && "C".equals(evaluationDeptRating.getNov())){
			countC += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getDece()) && "C".equals(evaluationDeptRating.getDece())){
			countC += 1;
		}
		evaluationDeptRating.setCcount(Convert.toStr(countC));
		return super.saveOrUpdate(evaluationDeptRating);
	}

	@Override
	public List<EvaluationDeptRating> list(String deptId, String deptName, String annual, HttpServletRequest request) {

		String code = request.getHeader("code");
		JSONObject json = remoteServiceBuilder.getGatewayUrl().getSysUser(code);
		MyuserResDTO user = JSONObject.parseObject(json.getJSONObject("data").toJSONString(), MyuserResDTO.class);

		user.getDeptOrg().getType();

		if("150".equals(user.getDeptOrg().getType())){
			deptId = user.getDeptOrg().getParentId();
		}

		if ("23031009".equals(deptId)) {//组织人事部
			deptId = "";
		}
		return baseMapper.list(deptId, deptName, annual);
	}
}
