package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ims.common.utils.StringUtils;
import com.ims.eval.entity.EvaluationPortalAttach;
import com.ims.eval.dao.EvaluationPortalAttachMapper;
import com.ims.eval.service.IEvaluationPortalAttachService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 考评首页附件 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-05-10
 */
@Service
public class EvaluationPortalAttachServiceImpl extends ServiceImpl<EvaluationPortalAttachMapper, EvaluationPortalAttach> implements IEvaluationPortalAttachService {

	@Override
	public boolean removeEvaluationPortalAttach(String id, List<String> portalIds) {

		QueryWrapper<EvaluationPortalAttach> qw = new QueryWrapper<>();

		if(StringUtils.isNotEmpty(id)){
			qw.lambda().eq(EvaluationPortalAttach::getId,id);
		}
		if(null != portalIds && portalIds.size()>0){
			qw.lambda().in(EvaluationPortalAttach::getPortalId,portalIds);
		}

		List<EvaluationPortalAttach> list = baseMapper.selectList(qw);
		if(null == list || list.size()<0){
			return true;
		}
		List<String> idList = list.stream().map(EvaluationPortalAttach::getId).collect(Collectors.toList());
		boolean b = this.removeByIds(idList);

		return b;
	}
}
